var comp = 
{
    data()
    {
        return {
            logo:"assets/image/logo.png",
            menu_items:[],
            popups:[],
            comp:"",
            props:{},
            events:null,
            scrolled:false,
            selected:"home"
        }
    },
    mounted() 
    {
        this.$root.nav = this;    

        this.$refs.scroll.addEventListener('scroll', this.onScroll);
    },
    async created() 
    {
       this.init();
    },
    methods: 
    {
        async init()
        {
            this.$root.$on("onHash",()=>this.processHash());

            this.processHash();
            await this.getMenuItems();
        },
        setMenuSelected(selected)
        {
           this.selected = selected;
        },
        onEnter()
        {
        },
        onMenu(item)
        {
            item.click?item.click(item):null;
        },
        setComp(data)
        {
           var hash = "#";
            
            if(UTIL.isObject(data))
            {
                var json = JSON.stringify(data);
                hash += btoa(json);
            }

            window.location = hash;
        },
        async processHash()
		{
            var query = UTIL.decodeHash();

            if(!UTIL.Empty(query))
            {
                this.comp = query.comp;
                this.props = query.props;
            }
            else
            {
                var data = 
                {
                    comp: "p-user-page",
                }
                this.setComp(data)
            }
		},
        async getMenuItems()
        {
            var user_items = 
            [
                this.buildTab("Quote","assets/svg/quote.svg",()=>this.setComp({comp:"p-quote-page"})),
                this.buildTab("Library","assets/svg/library.svg",()=>this.setComp({comp:"p-library-page"})),
                this.buildTab("Tasks","assets/svg/tasks.svg",()=>this.setComp({comp:"p-tasks-page"})),
            ];

            var items = 
            [
                this.buildTab("User","assets/svg/user.svg",()=>this.setComp({comp:"p-user-page"})),
                this.buildTab("Settings","assets/svg/setting.svg",()=>this.setComp({comp:"p-settings-page"})),
            ]

            var level = await this.getLevel();
            console.log(level);
            if(level>0)
            {
                user_items.push(...items);
                this .menu_items = user_items;
            }
            else this.menu_items = items;
        },
        async getLevel()
        {
            var hash = localStorage.getItem('user_hash');
            
            var path = "./db/user.php";
            
            var data = { hash:hash };
            
            var req = 
            {
                action:"getLevel",
                input: data
            }
            
            return (await UTIL.apiCall(path,req)||{}).auth_level;
        },
        
        onScroll()
        {
            this.scrolled = this.$refs.scroll.scrollTop!=0
        },
        onTop()
        {
            this.$refs.scroll.scrollTo(
            {
                top: 0,
                behavior: "smooth"
            });
        },
        buildTab(name,path,onclick)
        {
            return{

                name:name,
                tag:(name||"").toLowerCase(),
                path:path,
                click:onclick
            }
        }
    }
}