var comp=
{
    props:["fields","value","search","arrow_left","arrow_right","show_edit","show_delete"],
    data() 
    {
        return {
            last:0,
            page:
            {
                cur:0,
                size:40
            }
        }
    },
    mounted() 
    {
        this.$parent.$emit("onMounted");    
        this.requestFetch()    
        
        this.last = UTIL.getLength(this.fields)-1;
    },
    watch:
    {
        search(val)
        {
            this.requestFetch();
        },
        fields:
        {
            deep:true,
            handler(val)
            {
               this.last = UTIL.getLength(val)-1;
            }
        }
    },
    methods: 
    {
		requestFetch()
		{
			var request = 
			{
				search:this.search,
				offset : this.page.cur,
				limit:this.page.size
			}
			this.$emit("onFetch",request);
		},
        onSelect(row)
        {
            this.$emit("onSelect",row);
        },
        getRowNumber(r_index,count)
        {
            return (isNaN(count)? r_index:count)+1;
        },
        getDate(millis)
        {
            
            return millis? new Date(millis).toUTCString():"N/A";
        },
        func(field,val)
        {
            return UTIL.isFunc(field.func)?field.func(val):val
        }
    },
}